#!/bin/sh
# find out where the build script is located
tdir=`echo "$0" | sed 's%[\\/][^\\/][^\\/]*$%%'`
test "x$tdir" = "x$0" && tdir=.
scriptdir=`cd $tdir; pwd`
# find src directory.  
# If scriptdir ends in SPECS, then topdir is $scriptdir/.. 
# If scriptdir ends in CYGWIN-PATCHES, then topdir is $scriptdir/../..
# Otherwise, we assume that topdir = scriptdir
topdir1=`echo ${scriptdir} | sed 's%/SPECS$%%'`
topdir2=`echo ${scriptdir} | sed 's%/CYGWIN-PATCHES$%%'`
if [ "x$topdir1" != "x$scriptdir" ] ; then # SPECS
  topdir=`cd ${scriptdir}/..; pwd`
else
  if [ "x$topdir2" != "x$scriptdir" ] ; then # CYGWIN-PATCHES
    topdir=`cd ${scriptdir}/../..; pwd`
  else
    topdir=`cd ${scriptdir}; pwd`
  fi
fi

tscriptname=`basename $0 .sh`
export PKG=`echo $tscriptname | sed -e 's/\-[^\-]*\-[^\-]*$//'`
export VER=`echo $tscriptname | sed -e "s/${PKG}\-//" -e 's/\-[^\-]*$//'`
export REL=`echo $tscriptname | sed -e "s/${PKG}\-${VER}\-//"`
export FULLPKG=${PKG}-${VER}-${REL}

# determine correct decompression option and tarball filename
if [ -e ${PKG}-${VER}.tar.gz ] ; then
  export opt_decomp=z
  export src_orig_pkg_ext=gz
elif [ -e ${PKG}-${VER}.tar.bz2 ] ; then
  export opt_decomp=j
  export src_orig_pkg_ext=bz2
fi

export src_orig_pkg_name=${PKG}-${VER}.tar.${src_orig_pkg_ext}
export src_pkg_name=${FULLPKG}-src.tar.bz2
export src_patch_name=${FULLPKG}.patch
export bin_pkg_name=${FULLPKG}.tar.bz2

export src_orig_pkg=${topdir}/${src_orig_pkg_name}
export src_pkg=${topdir}/${src_pkg_name}
export src_patch=${topdir}/${src_patch_name}
export bin_pkg=${topdir}/${bin_pkg_name}
export srcdir=${topdir}/${PKG}-${VER}
export objdir=${srcdir}/.build
export instdir=${srcdir}/.inst
export srcinstdir=${srcdir}/.sinst
export checkfile=${topdir}/${FULLPKG}.check

# Make sure /usr/bin/emacs from the cygwin distribution is found first
# and not xemacs in /usr/local/bin if it exists
export PATH=/usr/bin:$PATH
# run on
host=i686-pc-cygwin
# if this package creates binaries, they run on
target=i686-pc-cygwin

prefix=/usr
sysconfdir=/etc
localstatedir=/var

exec_prefix=${prefix}
bindir=${prefix}/bin
sbindir=${prefix}/sbin
libexecdir=${sbindir}
datadir=${prefix}/share
sharedstatedir=${prefix}/com
libdir=${prefix}/lib
includedir=${prefix}/include
infodir=${datadir}/info
mandir=${datadir}/man
docdir=${datadir}/doc/${PKG}-${VER}

MY_CFLAGS="-O2"
MY_LDFLAGS=

mkdirs() {
  (cd ${topdir} && \
  rm -fr ${objdir} ${instdir} ${srcinstdir} && \
  mkdir -p ${objdir} && \
  mkdir -p ${instdir} && \
  mkdir -p ${srcinstdir} )
}
prep() {
  (cd ${topdir} && \
  tar xv${opt_decomp}f ${src_orig_pkg} ; \
  cd ${topdir} && \
  patch -p0 < ${src_patch} 
  && mkdirs )
}
conf() {
  (cd ${objdir} && \
  lndir ../ && \
  rm -rf .build .inst .sinst CYGWIN-PATCHES       && \
  CFLAGS="${MY_CFLAGS}" LDFLAGS="${MY_LDFLAGS}"      \
  ${srcdir}/configure                                \
  --srcdir=${srcdir}                                 \
  --prefix=${prefix}                                 \
  --exec-prefix=${exec_prefix}                       \
  --bindir=${bindir}                                 \
  --sbindir=${sbindir}                               \
  --libexecdir=${libexecdir}                         \
  --datadir=${datadir}                               \
  --sysconfdir=${sysconfdir}                         \
  --sharedstatedir=${sharedstatedir}                 \
  --localstatedir=${localstatedir}                   \
  --libdir=${libdir}                                 \
  --includedir=${includedir}                         \
  --infodir=${infodir}                               \
  --mandir=${mandir}                                 \
  --with-x                                           \
  --with-lasergnu                                    \
  --with-gihdir=${datadir}                           \
  --with-readline=gnu                                \
  --enable-history-file                              \
  --with-png                                         \
  --with-gd                                          \
  --with-gif                                         \
  --with-pdf                                         \
  --enable-thin-splines                              \
  --enable-iris                                      \
  --enable-mgr                                       \
  --enable-fiterrvars                                \
  --enable-rgip                                      \
)
}
build() {
 (
  cd ${objdir}               && \
  CFLAGS="${MY_CFLAGS}" make && \
  cd docs                    && \
  make html ps               && \
  cd psdoc                   && \
  make
 )
}
check() {
  (cd ${objdir} && \
  make test | tee ${checkfile} 2>&1 )
}
clean() {
  (cd ${objdir} && \
  make clean )
}
install() {
  (cd ${objdir} && \
  make install DESTDIR=${instdir} \
               GIHDIR=${datadir}
  for f in ${prefix}/share/info/dir ${prefix}/info/dir ; do
    if [ -f ${instdir}${f} ] ; then \
      rm -f ${instdir}${f} ; \
    fi ;\
  done &&\
  for d in ${prefix}/share/doc/${PKG}-${VER} ${prefix}/share/doc/Cygwin \
           ${sysconfdir}/postinstall ; do
    if [ ! -d ${instdir}${d} ] ; then
      mkdir -p ${instdir}${d} ;\
    fi ;\
  done &&\
  templist=""; \
  for f in ${srcdir}/ANNOUNCE ${srcdir}/CHANGES ${srcdir}/INSTALL* \
           ${srcdir}/KNOWNBUG ${srcdir}/LICENSE ${srcdir}/README* \
           ${srcdir}/TODO ${srcdir}/COPYING ${srcdir}/CodeStyle \
           ${srcdir}/Copyright* ${srcdir}/PORTING ${srcdir}/NEWS \
           ${srcdir}/FAQ ${srcdir}/BUGS ${srcdir}/ChangeLog ; do \
    if [ -f $f ] ; then \
      templist="$templist $f"; \
    fi ; \
  done && \
  /usr/bin/install -m 755 ${srcdir}/src/lasergnu ${instdir}${bindir} && \
  cp    ${objdir}/tutorial/tutorial.dvi ${instdir}${docdir}          && \
  cp -r ${srcdir}/demo ${instdir}${docdir}                           && \
  cp    ${objdir}/demo/binary* ${instdir}${docdir}/demo              && \
  cp -r ${srcdir}/pm3d ${instdir}${docdir}                           && \
  cp    ${objdir}/docs/*.ps ${instdir}${docdir}                      && \
  cp -r ${srcdir}/docs/psdoc ${instdir}${docdir}                     && \
  cp    ${objdir}/docs/psdoc/*.ps ${instdir}${docdir}/psdoc          && \
  rm -f ${instdir}${docdir}/demo/Makefile*                           && \
  rm -f ${instdir}${docdir}/tutorial/Makefile.am*                    && \
  rm -f ${instdir}${docdir}/tutorial/Makefile.in                     && \
  rm -f ${instdir}${docdir}/tutorial/makefile.dst                    && \
  if [ ! "x$templist" = "x" ]; then \
    /usr/bin/install -m 644 $templist \
         ${instdir}${prefix}/share/doc/${PKG}-${VER} ;
  fi && \
  if [ -f ${srcdir}/CYGWIN-PATCHES/${PKG}.README ]; then \
    /usr/bin/install -m 644 ${srcdir}/CYGWIN-PATCHES/${PKG}.README \
      ${instdir}${prefix}/share/doc/Cygwin/${PKG}-${VER}.README ; \
  else \
    if [ -f ${srcdir}/CYGWIN-PATCHES/README ]; then \
      /usr/bin/install -m 644 ${srcdir}/CYGWIN-PATCHES/README \
        ${instdir}${prefix}/share/doc/Cygwin/${PKG}-${VER}.README ; \
    fi ;\
  fi ;\
  if [ -f ${srcdir}/CYGWIN-PATCHES/postinstall.sh ] ; then \
  /usr/bin/install -m 755 ${srcdir}/CYGWIN-PATCHES/postinstall.sh \
      ${instdir}${sysconfdir}/postinstall/${PKG}.sh
  fi )
}
strip() {
  (cd ${instdir} && \
  find . -name "*.dll" | xargs strip > /dev/null 2>&1
  find . -name "*.exe" | xargs strip > /dev/null 2>&1
  true )
}
list() {
  (cd ${instdir} && \
  find . -name "*" ! -type d | sed 's/\.\/\(.*\)/\1/'
  true )
}
pkg() {
  (cd ${instdir} && \
  tar cvjf ${bin_pkg} * )
}
mkpatch() {
  (cd ${srcdir} && \
  find . -name "autom4te.cache" | xargs rm -rf > /dev/null
  tar xv${opt_decomp}f ${src_orig_pkg} ;\
  mv ${PKG}-${VER} ../${PKG}-${VER}-orig && \
  cd ${topdir} && \
  diff -urN -x '.build' -x '.inst' -x '.sinst' \
    ${PKG}-${VER}-orig ${PKG}-${VER} > \
    ${srcinstdir}/${src_patch_name} ; \
  rm -rf ${PKG}-${VER}-orig )
}
spkg() {
  (mkpatch && \
  cp ${src_orig_pkg} ${srcinstdir}/${src_orig_pkg_name} && \
  cp $0 ${srcinstdir}/`basename $0` && \
  cd ${srcinstdir} && \
  tar cvjf ${src_pkg} * )
}
finish() {
  rm -rf ${srcdir} 
}
case $1 in
  prep)	prep ; STATUS=$? ;;
  mkdirs)	mkdirs; STATUS=$? ;;
  conf)	conf ; STATUS=$? ;;
  build)	build ; STATUS=$? ;;
  check)	check ; STATUS=$? ;;
  clean)	clean ; STATUS=$? ;;
  install)	install ; STATUS=$? ;;
  list)	list ; STATUS=$? ;;
  strip)	strip ; STATUS=$? ;;
  package)	pkg ; STATUS=$? ;;
  pkg)	pkg ; STATUS=$? ;;
  mkpatch)	mkpatch ; STATUS=$? ;;
  src-package)	spkg ; STATUS=$? ;;
  spkg)	spkg ; STATUS=$? ;;
  finish) finish ; STATUS=$? ;;
  all) prep && conf && build && install && \
     strip && pkg && spkg && finish ; \
	  STATUS=$? ;;
  *) echo "Error: bad arguments" ; exit 1 ;;
esac
exit ${STATUS}
